const spawn = require('child_process').spawn;
let process;

function start() {
  process = spawn('node', ['bot.js']);

  process.stdout.on('data', (data) => {
    console.log(`stdout: ${data}`);
  });

  process.stderr.on('data', (data) => {
    console.error(`stderr: ${data}`);
  });

  process.on('close', (code) => {
    console.log(`child process exited with code ${code}`);
    console.log('Restarting in 5 seconds...');
    setTimeout(start, 5000);
  });
}

function stop() {
  if (process) {
    process.kill();
  }
}

start();